
/*
if( (++gulT2_Ticks) > (BEFORE_DWORD_LIMIT) ) //0xFFFFFF00 //Um einen Zhlerberlauf zu verhindern !
	{		
	gulT2_Ticks = 0;  //Wegens Ausfallgefahr bei berlauf = MINUS
	};
	
*/


#ifndef MAIN_HEADER  //Prevents multiple includes
#define MAIN_HEADER

#define TEST_ROUTINE_ENABLED	0
#define USED_HEX_CONVERSION		0

#define UART_USE_ENABLED		1
#define UART_ERRORMSG			1
#define ADC_USED_ENABLED		1

#define USE_TOGGLE_FLAG			0
#define USE_ERROR_FLAG			0 

//TickCounter  MUSS SEIN !!!
#define TIMER0_USED				1 		
#define TIMER1_USED				0
#define TIMER_TICK_USED			1	
	
#define TIMER_2_PWM_ENABLED		1

#define EEPROM_USED				1
#define KEY_USED				1

#define TEXT_SERVICE_USE_ENABLED		1
//sfr |= _BV(bit)  ---  sfr &= ~(_BV(bit))
//#define MSG							0
#define LCD_4Bit_Module_USED			0
#define LCD_MSG_USED					0 //Never  forget, PB3 ist mit 10K pulldown zu schalten
//Timeout von LCD wird simuliert
#define COM_TX_ENABLED					0
#define LCD_MENUE_USED					0
#define ENDORDER_CMD_ECHO_ENABLED		1
//TWI


/*
REGISTER = WERT;
sbi (PORTB, 2);   // Setzt Pin 2 auf Logisch 1 (EIN)
cbi (PORTB, 2);   // Setzt Pin 2 auf Logisch 0 (AUS)
PIN
X = PORT // inp (PINB)--> bPortD = inp (PIND);

Wobei es hier sehr wichtig ist, als Portadresse nicht etwa das
Portregister PORTx zu verwenden,sondern die Porteingangsadresse PINx.
Dies ist ein oft gemachter Fehler!
*/


/*
Jedes Port hat drei Register
DDxN
PORTXn
PINxn
IF PortX ist INPUT an PORTX= set to 1, PullUP IS ENABLED
*/


/*
Text verbraucht Speicher
Statt Pointer geht evtl auch diese Form
TESTEN !!!
const uint8_t MCA_CRLFSTR[] __attribute__ ((section (".text"))) = {13,10,0};
//Versus diesr Form, die Speicher verbraucht !! ROCKEN ALS EINFGESTRING DEFINIERT.
#define MCA_CRLFSTR (const char){CR,LF,0}  //redefined 

*/


//For compatibility for OLDER Compilers
//#define	sbi(sfr, bit)   (_SFR_BYTE(sfr) |= _BV(bit))
//#define	cbi(sfr, bit)   (_SFR_BYTE(sfr) &= ~_BV(bit))


#define STRMAX 63
#define NUMMAX 31
#define RX_STRMAX 63

#define DELIMITER		','
#define DELIMITERSTR	","
#define COMAMNDSIZEMAX  16 //16 Commands

#define BYTE_LIMIT 255				//uint8_t					uint8_t
#define WORD_LIMIT 65535			//unsigned short				uint16_t
#define DWORD_LIMIT 4294967295UL	//unsigned long					uint32_t
//Wird benutz um T2 berlauf zu berwachen !!
#define BEFORE_DWORD_LIMIT 429496000UL	//unsigned long					uint32_t
#define QWORD_LIMIT 18446744073709551615ULL	//unsigned long long 	uint64_t

#define LOW_NIPPEL_MASK		0x0F
#define HIGH_NIPPEL_MASK	0xF0

#define USED_ADC_CHANNELS	4
#define UREF	5.0	//Volt
#define UCALIBRATE_REF 2.513	//Volt
#define ADC_RESOULTION	1024
typedef struct
	{
	int16_t ai16ValZero[USED_ADC_CHANNELS];	//offen/geschlossen Zeit des Schalter fr Debounce
	int16_t ai16calValRef[USED_ADC_CHANNELS];	//offen/geschlossen Zeit des Schalter fr Debounce
	}ADC_CALIBTRATE_TYPE;


//Tastatur
typedef struct
	{
	uint32_t ulEventTime;	//offen/geschlossen Zeit des Schalter fr Debounce
	uint8_t ucKeyStat;		//Status, Fr das Speichern des Status der Taste
	uint8_t ucKey;			// Tasten
	}KEYSTRUCT_TYPE;


typedef struct
	{
	char caCmd[COMAMNDSIZEMAX +1];
	uint8_t ucCmdID;
	float fCmdVal_1;
	float fCmdVal_2;
//uint8_t ucCmdID;
	}COMMAND_TYPE;

#if EEPROM_USED == 1
typedef struct
	{
	uint8_t u8LowerLimit;
	uint8_t u8UpperLimit;
//uint8_t ucCmdID;
	}EEPROM_DATA_TYPE;

typedef struct
	{	
	uint8_t ucaInEEPROMStr[12];	//Fr strlen( EEPROMVALID) = 11 + 1
	}EEPROM_STR_TYPE;	
#endif



/*
typedef struct
	{	
	uint8_t ucaInEEPROMStr[12];	//Fr strlen( EEPROMVALID) = 11 + 1
	}EEPROM_STR_TYPE;	
*/

//TTT
// Hardwareassignment
//#define           11059200L Hz   
//#define           3686400L Hz   
//F_CPU  in makefile !!!
//CPU = 16000000L
#define SYSCLK			F_CPU
//#define UART_BAUD_RATE	9600	/* 9600 baud */
//define UART_BAUD_RATE	19200
#define UART_BAUD_RATE	57600
//SYSCLK/256= 62500	14400
//SYSCLK/64 = 
//SYSCLK/1024 =15625     Counts/Sec  !!!!
// Sekunden fr vollen Timerlauf 
// 1/F = 1/16000000  =  0.0000000625   Hz minimal	

#define SYSCLK_256	(SYSCLK / 256) // =  62500 //z.B.Timer2 berlauf / 256  / Teilerfaktor

#define DISABLE_ALL_PULLUP_MAC	(SFIOR |= _BV(PUD));
#define ENABLE_ALLUP_SCL_MAC	(SFIOR &= ~(_BV(PUD)));


//DELAY
//#define TCCR2_CLK_64	0x04	//675 = 0,0014814814814814814814814814814815   mS Interrrupt
// 1 TICK = 1.4814814814814814814814814814815 ms 
//NUR UNGEFHR
//BERECHUNG Xtime(ms) / 1.48....
#define TIMEOUT_1_5MS 	1 
#define TIMEOUT_2_9MS 	2
#define TIMEOUT_4_4MS 	3
#define TIMEOUT_10_3MS 	7
#define TIMEOUT_100_7MS	68
#define TIMEOUT_500_7MS	338
#define TIMEOUT_1S 		675		//!!  uint16_t
#define TIMEOUT_5S 		3375	//!!  uint16_t

//REGISTER
#define TCCR0_FAST_PWM	0x48	//Mode 3
#define TCCR0_OC0_MODE	0x20	//Clear ON compare Match
#define TCCR0_OC0_DISCONNECT_MODE	0x00
#define TCCR0_CLK_STOP	0x00	
#define TCCR0_CLK_0		0x01	
#define TCCR0_CLK_8		0x02	
#define TCCR0_CLK_64	0x03	
#define TCCR0_CLK_256	0x04	
#define TCCR0_CLK_1024	0x05	
#define TCCR0_EXT_CLK_FALL_T0	0x06	
#define TCCR0_EXT_CLK_RISE_T0	0x07	


// FOC2 / WGM20 / COM21 / COM20 / WGM21 / CS22 / CS21 / CS20 
#define TCCR2_WGM_NORMAL		0x00
#define TCCR2_CTC_MODE			0x08 //0000 1000
#define TCCR2_COM_NORMALPORT	0x00
#define TCCR2_CLK_STOP			0x00
#define TCCR2_FAST_PWM			0x48	//Mode 3
#define TCCR2_OC2_FAST_PWM_MODE	0x20	
#define TCCR2_CS_BIT			0x02	//Mode 3
#define TCCR2_CLK_1024	0x07	
#define TCCR2_CLK_256	0x06	
#define TCCR2_CLK_128	0x05
#define TCCR2_CLK_64	0x04	//
#define TCCR2_CLK_32	0x03
#define TCCR2_CLK_8		0x02	//	1/F = 
#define TCCR2_CLK_0		0x01	
#define TCCR2_CLK_STOP	0x00	
//TIMER2 WIRD BERECHNET /z.B:OverFLow SYSCLK /  256 / TCCR2_CLK_64 =  OVL/Sec
// 1/OVLS = 1/ = 
//-----> 

//#define TCCR1B_CLOCKSEL_CTC1 		0x08	//Clear Timer/Counter  on Compare Match Timer/Counter 1
#define TCCR1B_CLOCKSEL_STOP		0x00	//Clock Select Bits
#define TCCR1B_CTC_MODE				0x08	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_1		0x01	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_8		0x02	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_64		0x03	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_256		0x04	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_1024	0x05	//Clock Select Bits



//INTERUPT CTRL REG //NICHT mit MCUCSR verwechseln !
#define MCUCR_LOWLEVEL_INT0		0x00	
#define MCUCR_ANYCHANGE_INT0	0x01 //=_BV(ISC01) 	
#define MCUCR_FALLING_EDGE_INT0	0x02	
#define MCUCR_RISING_EDGE_INT0	0x03

#define MCUCR_LOWLEVEL_INT1		0x00	
#define MCUCR_ANYCHANGE_INT1	0x04 //=_BV(ISC10) 	
#define MCUCR_FALLING_EDGE_INT1	0x08	
#define MCUCR_RISING_EDGE_INT1	0x0C

#define GATE_ANYCHANGE_INT1_MODE_MAC	(MCUCR |= MCUCR_ANYCHANGE_INT1)


//Global Interrrupt CTRL REG
#define GICR_INT0_ON_MAC	(GICR |= _BV(INT0)) //_BV(INT0)
#define GICR_INT0_OFF_MAC	(GICR &= ~(_BV(INT0)))
#define GICR_INT1_ON_MAC	(GICR |= _BV(INT1))
#define GICR_INT1_OFF_MAC	(GICR &= ~(_BV(INT1)))
#define GICR_INT_0u1_OFF_MAC	(GICR &= 0x3F)  //SIEHE DATENBLATT


#define RCO_B_INT_ON_MAC	GICR_INT0_ON_MAC 
#define RCO_B_INT_OFF_MAC	GICR_INT0_OFF_MAC
#define GATE_INT1_ON_MAC	GICR_INT1_ON_MAC
#define GATE_INT1_OFF_MAC	GICR_INT1_OFF_MAC


#define OVERFLOW_CNT_ON_INT0_MAC	RCO_B_INT_ON_MAC
#define OVERFLOW_CNT_OFF_INT0_MAC	RCO_B_INT_OFF_MAC

#define GATE_ALL_EVENT_ON_INT1_MAC	GATE_INT1_ON_MAC
#define GATE_ALL_EVENT_OFF_INT1_MAC	GATE_INT1_OFF_MAC

//GIFR  I_FLAG
#define GIFR_INTF0_SET_MAC	(GIFR |= _BV(INTF0)) //_BV(INT0)
#define GIFR_INTF0_CLR_MAC	(GIFR &= ~(_BV(INTF0)))
#define GIFR_INTF1_CLR_MAC	(GIFR |= _BV(INTF1))
#define GIFR_INTF1_SET_MAC	(GIFR &= ~(_BV(INTF1)))
#define GIFR_INTF_0u1_CLR_MAC	(GIFR &= 0x3F) //Siehe Datenblatt = letzten beiden Bits



//PORTB 
#define MOSI_I       5
#define MISO_0       6
#define SCK_I        7

//#define TCCR1B_CLOCKSEL_CTC1 		0x08	//Clear Timer/Counter  on Compare Match Timer/Counter 1
#define TCCR1B_CLOCKSEL_STOP		0x00	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_1		0x01	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_8		0x02	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_64		0x03	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_256		0x04	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_1024	0x05	//Clock Select Bits



//EEPROM
#define EEPROM_SECTION  __attribute__ ((section (".eeprom")))
#define IEEPROM_SIZE	512	//Interne EEPROM
#define EE_DUMMYLOAD 0x5AA5 //unwahrsch. wert 0101 1010 1010 0101
//If using 8 block by 512 max = 64 Byte/block
//#define IEEPROM_SECTIONSIZE	64   //by 8 Section




//INTERRUPT
#define INTx_INPORT	PIND
//#define INT1_MASK	0x08  //PD3
//#define INT0_MASK	0x04  //PD2
#define INT0_PIN_NR	PD2
#define INT1_PIN_NR	PD3


//PORTB
#define TWI_DIRREG		DDRC
#define TWI_OUT_PORT	PORTC
#define TWI_IN_PORT		PINC
#define TWI_SDA			PC4		//PC4	OUT
#define TWI_SCL			PC5		//PC5	IN

/*
#define Clr_TWI_SDA_MAC	 	TWI_OUT_PORT &= ~PC_SDA_BIT;	 
#define Set_TWI_SDA_MAC	 	TWI_OUT_PORT |= PC_SDA_BIT;	 
#define TWI_SCL_IS_HIGH		(TWI_IN_PORT & PC_SCL_BIT )
#define TWI_SCL_IS_LOW		(!(TWI_IN_PORT & PC_SCL_BIT))
*/


//PORTD TX/RX ERST MAL FR  FLAGS
#define PD0_RX_BIT	0x01	//PIN2
#define PD1_TX_BIT	0x02	//PIN3


//========================================================================

//TIMERS
//TIMER2  = is 61 miliseconds Timer ~approx.
// 16MhZ / 256/ 256  = 61,03515625 Hz
// T= 1/f = 0.016384 ms / Interrupt
#define TIMER2_INT_FREQUENCY	244.140625
#define TIMER2_INTPERIODE		0.004096 //1/TIMER2_INT_FREQUENCY BY EVERY OVERFLOW = 1 Second!
#define ONE_SECOND_TICKS		244	//1/ TIMER2_INTPERIODE

#define EiN_10TEL_SEKUNDE 24

//PORT_ASSIGMNEMTS
//Bit usage, use by sbi, cbi

//MACRO
// HARWARE MAKROS

//#define LED_GRUEN_ON_MAC	sbi(LED_PORT, LED_GRUEN);
//#define LED_GRUEN_OFF_MAC	cbi(LED_PORT, LED_GRUEN);

//-----------------------

//MASKENBITS


//FLAG MEANING USED VOR INTERRUPT
/*
BIT 7
BIT 6
BIT 5
BIT 4
BIT 3
BIT 2
BIT 1
BIT 0 = INT0 = 0x01
*/

#define WDTO_2S   7 //WatchDog
//SOFTWARE USED DEFINES


#define ASC_CR	13
#define ASC_LF	10

//COMMAND
#define STXSIZEMAX	3
#define ETX			ASC_CR

#define DELIMITER		','
#define DELIMITERSTR	","


//delay.h 8-bit count, 
//EIn Aufruf von _delay_loop_2 = 4 Cyclen lan = 0.00000025 = 0.250 NanoSecunden
/*
#define OneCycletime	0.0000000625  // 1 / F_CPU
#define DELAYCYCLE_3	0.0000001875 //375ns fr eine Pause //CPU_CYCLE_TIME *3 fr 8 Bit
#define DELAYCYCLE_4 	0.00000025 //500ns fr eine!!! Pause= _delay_loop_2(1); //CPU_CYCLE_TIME *4 fr 16Bit
// 500nS sind 8 * OneCycletime
//1ms= 16000 * OneCycletime
#define DELAY_1NS		4	//4 * 4 Cycles
#define DELAY_1000NS	4000 //()
*/

#define FLOAT_OVERFLOW_2_19 0x7FFFFUL //= liegt VOR berlauf !!! 524287	Um es Vor!! DEM BERLAUF ABZUFANGEN
#define HALF_FLOAT_OVERFLOW 0x3FFFFUL

#define BITS_PER_BYTE	8
#define PORTB_BITS	6
#define PORTC_BITS	6
#define PORTD_BITS	8


//CHECK PUD = PULLUPDISSABLE in SFIOR 
//PORT B  	//1=OUT 6BIT
//1=OUT
#define PORTB_DDRX_OUT_MASK 	0b00011100
#define PORTB_PRESET_PULLMASK	0b00000011	//auf stecker
//PORT C 	TWI //1=OUT  0 = IN  6BIT
//STARTWERTE  
//ADC
#define PORTC_DDRX_OUT_MASK		0b00000000	//ADC
#define PORTC_PRESET_PULLMASK	0b00000000	

//PORT D	//1=OUT 8 BIT 
//RX/TX
#define PORTD_DDRX_OUT_MASK		0b00000010	//
#define PORTD_PRESET_PULLMASK	0b00000001	//TX AUF 1 RX PULL auf 1





//TEST AND DEBUG SECTION
// PORTD 7.BIT
//#define USE_TOGGLE_FLAG
#if  USE_TOGGLE_FLAG == 1 	
	#define  TESTBIT_DIRREG		DDRC
	#define  TESTBIT_PORT		PORTC
	#define TESTBIT_BIT			0x01
	#define TESTBIT_INVERT_BIT	0xFE
	#define INIT_TESTBIT_REG_MAC	(TESTBIT_DIRREG |= TESTBIT_BIT);
	#define SET_TESTBIT_MAC			(TESTBIT_PORT |= TESTBIT_BIT);
	#define CLR_TESTBIT_MAC			(TESTBIT_PORT &= TESTBIT_INVERT_BIT);
	extern void ToggleTEST_BIT(uint8_t ucCnt);
#endif

//TIMER
#define TIMSK_TOIE0_FLAG	0x01
#define TIMSK_TOIE1_FLAG	0x04
#define TIMSK_OCIE1B_FLAG	0x08
#define TIMSK_OCIE1A_FLAG	0x10
#define TIMSK_TICIE1_FLAG	0x20
#define TIMSK_TOIE2_FLAG	0x40
#define TIMSK_OCIE2_FLAG	0x80

#define TIMSK_T0_CLR_ALL_MASK 0b11111100
#define TIMSK_T1_CLR_ALL_MASK 0b11000011
#define TIMSK_T2_CLR_ALL_MASK 0b00111111


#define TIFR_TOV0_TIMER_OVERFLOW_FLAG	0x01
#define TIFR_OCF0_OUT_PCOMPARE_FLAG		0x02
#define TIFR_TOV1_TIMER_OVERFLOW_FLAG	0x04
#define TIFR_OCF1A_OUTP_COMPARE_A_FLAG	0x10
#define TIFR_OCF1B_OUTP_COMPARE_B_FLAG	0x08
#define TIFR_TOV2_TIMER_OVERFLOW_FLAG	0x40
#define TIFR_OCF2_OUTP_COMPARE_FLAG		0x80

//INTERRUPT MODE
//#define MCUCR_INT0_LOWLEVEL_CLRMASK	0xFC
#define MCUCR_INT0_LOWLEVEL		0x00
#define MCUCR_INT0_ANY_CHANGE	0x01
#define MCUCR_INT0_FALLING_EDGE	0x02
#define MCUCR_INT0_RISING_EDGE	0x03
#define MCUCR_INT0_CLEAR_MASK	0xFC

//#define MCUCR_INT1_LOWLEVEL_CLRMASK	0xF3
#define MCUCR_INT1_LOWLEVEL		0x00
#define MCUCR_INT1_ANY_CHANGE	0x04
#define MCUCR_INT1_FALLING_EDGE	0x08	//_BV(ISC11)
#define MCUCR_INT1_RISING_EDGE	0x0C
#define MCUCR_INT1_CLEAR_MASK	0xF3
 

#define GICR_INT1_FLAG	0x80
#define GICR_INT0_FLAG	0x40
#define GICR_INT2_FLAG	0x20

#define GIFR_INTF1_FLAG	0x80
#define GIFR_INTF0_FLAG	0x40
#define GIFR_INTF2_FLAG	0x20

//TIMERS
#define TCCR0_FAST_PWM	0x48	//Mode 3
#define TCCR0_OC0_MODE	0x20	//Clear ON compare Match
#define TCCR0_OC0_DISCONNECT_MODE	0x00
#define TCCR0_CLK_1024	0x05	//~61,035 PWM
#define TCCR0_CLK_256	0x04	//244,14Hz PWM
#define TCCR0_CLK_64	0x03	//976,56Hz PWM
#define TCCR0_CLK_8		0x02	//7812 Hz PWM
#define TCCR0_CLK_0		0x01	//62500 PWM
#define TCCR0_CLK_STOP_MASK	0xF8	

#define TCCR2_WGM_NORMAL	0x00
#define TCCR2_CTC_MODE		0x08 //0000 1000
#define TCCR2_COM_NORMALPORT	0x00
#define TCCR2_FASTPWM		0x48	//Mode 3
#define TCCR2_CLK_0			0x01
#define TCCR2_CLK_8			0x02
#define TCCR2_CLK_32		0x03
#define TCCR2_CLK_64		0x04
#define TCCR2_CLK_128		0x05
#define TCCR2_CLK_256		0x06
#define TCCR2_CLK_1024		0x07
#define TCCR2_CLK_STOP_MASK	0xF8

//TCCR1A

#define TCCR1A_CTC_MODE			0x00	//WGM11 WGM10  = 0
#define TCCR1A_FAST_PWM_ICR1	0x02 //WGM11
#define TCCR1A_FAST_PWM_OCR1A	0x03 //WGM11 WGM10 

//#define TCCR1B_CLOCKSEL_CTC1 		0x08	//Clear Timer/Counter  on Compare Match Timer/Counter 1
#define TCCR1B_CLOCKSEL_STOP		0x00	//Clock Select Bits
#define TCCR1B_CTC_MODE				0x08	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_1		0x01	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_8		0x02	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_64		0x03	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_256		0x04	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_1024	0x05	//Clock Select Bits
#define TCCR1B_CLK_STOP_MASK		0xF8

#define TC1_USED_CLOCKS_PER_SEC		15625	//16^6 / 1024


//ADC //AT8
#define ADMUX_MUX0	0x01
#define ADMUX_MUX1	0x02
#define ADMUX_MUX2	0x04
#define ADMUX_MUX3	0x08
#define ADMUX_MUX_1_23V	0xE0
#define ADMUX_MUX_GND	0xF0
#define ADMUX_ADLAR	0x20
#define ADMUX_REFS0	0x40
#define ADMUX_REFS1	0x80
#define ADC_MUX_MASK	0x3F

//PRESCALER
#define ADCSRA_ADPS0	0x01
#define ADCSRA_ADPS1	0x02
#define ADCSRA_ADPS2	0x04
#define ADCSRA_ADIE		0x08
#define ADCSRA_ADIF		0x10		//INTERRRUPT FLAG
#define ADCSRA_ADFR		0x20	//FREE RUNNNG SEL
#define ADCSRA_ADSC		0x40	//START  //while (ADCSRA & _BV(ADSC) ) 
#define ADCSRA_ADEN		0x80	//Enable

#define  ADCSRA_PRESCALER_2		0x01
#define  ADCSRA_PRESCALER_4		0x02
#define  ADCSRA_PRESCALER_8		0x03
#define  ADCSRA_PRESCALER_16	0x04
#define  ADCSRA_PRESCALER_32	0x05
#define  ADCSRA_PRESCALER_64	0x06
#define  ADCSRA_PRESCALER_128	0x07
//WERT IN ADCW

#define ADC_X1_CHANNEL	0
#define ADC_X2_CHANNEL	1
#define ADC_Y1_CHANNEL	3
#define ADC_Y2_CHANNEL	4

#define PULS_PER_SECONDTICK_T0	 977	//RUNDUNG
#define PULS_500MS_TICK_T0		244
#define PULS_250MS_TICK_T0		122
#define PULS_100MS_TICK_T0		98
#define PULS_50MS_TICK_T0		49
#define PULS_1MS_TICK_T0		1


//Status
#define KEYSTAT_PRESSED				0x01	//	pressed
#define KEYSTAT_PRESSED_DETECT		0x02
#define KEYSTAT_RELEASED			0x04
#define KEYSTAT_RELEASE_DETECT		0x08
//--
#define KEYSTAT_INTEVENT			0x10	// one int
#define KEYSTAT_VALID				0x80	// Now Start Action
//--
#define KEYSTAT_CLR_PRESSED_MASK	0xFC	// 1111 1100
#define KEYSTAT_CLR_RELEASE_MASK	0xF3	// 1111 0011
//gstExtKey.ucKey gstExtKey.ucKeyStat  gucPollingStat



#define PREDEF_SERVO_UPPERLIMIT 10 // pwm,8
#define PREDEF_SERVO_LOWERLIMIT 29 	//pwm,34


#define PWM2_DIR_REG			DDRB
#define SERVO_ENABLE_PORT		PORTB
#define SERVO_PWM_PORT			PORTB

#define LED_REMOTE_PORT			PORTB
#define KEY_REMOTE_POLLING_PORT	PINB

#define KEYS_REMOTE_MASK	0x03
#define KEY_OBEN_BIT 	0x01
#define KEY_UNTEN_BIT	0x02

#define	LED_REMOTE_BIT	0x04
#define SERVO_ENABLE_BIT 0x10


#define PWM_ON_PORT_OUT() (PWM2_DIR_REG |= OC2_PWM_BIT);

#define ENABLE_SERVO_MAC()	(SERVO_ENABLE_PORT &= ~SERVO_ENABLE_BIT);
#define DISABLE_SERVO_MAC()	(SERVO_ENABLE_PORT |= SERVO_ENABLE_BIT);

#define DISABLE_LED_MAC()	(SERVO_ENABLE_PORT |= LED_REMOTE_BIT);
#define ENABLE_LED_MAC()	(SERVO_ENABLE_PORT &= ~LED_REMOTE_BIT);


#endif  //MAIN_HEADER
